package org.objectweb.jonas.webapp.jonasadmin.monitoring;

import java.io.IOException;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.jmx.J2eeObjectName;
import org.objectweb.jonas.jmx.JonasManagementRepr;
import org.objectweb.jonas.webapp.jonasadmin.JonasAdminJmx;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;
import org.objectweb.jonas.webapp.jonasadmin.WhereAreYou;

public class DisplayNodeInfoAction extends JonasBaseAction {

    public ActionForward executeAction(ActionMapping p_Mapping,
            ActionForm p_Form, HttpServletRequest p_Request,
            HttpServletResponse p_Response) throws IOException,
            ServletException {
        // Form used
        WhereAreYou oWhere = (WhereAreYou) p_Request.getSession().getAttribute(
                WhereAreYou.SESSION_NAME);
        String sDomainName = oWhere.getCurrentDomainName();

        String serverName = oWhere.getCurrentJonasServerName();

        NodeInfoForm oForm = (NodeInfoForm) p_Form;
        try {

            /*
             * Server related info
             */
            oForm.setServerName(p_Request.getParameter("node"));

            ObjectName on = new ObjectName(sDomainName
                    + ":type=ServerProxy,name=" + oForm.getServerName());
            try {
                oForm.setState((String) JonasManagementRepr.getAttribute(on,
                        "State", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setHostName((String) JonasManagementRepr.getAttribute(on,
                        "HostName", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setAllThreadsCount((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "AllThreadsCount", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJavaVersion((String) JonasManagementRepr.getAttribute(on,
                        "JavaVersion", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJavaVendor((String) JonasManagementRepr.getAttribute(on,
                        "JavaVendor", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentTotalMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentTotalMemory", serverName).toString())
                        .intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentUsedMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentUsedMemory", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJOnASVersion((String) JonasManagementRepr.getAttribute(on,
                        "JOnASVersion", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setProtocols((String) JonasManagementRepr.getAttribute(on,
                        "Protocols", serverName));
            } catch (RuntimeException e) {
                // Attibute missing
            }
            /*
             * JDK5
             */

            /*
             * Tomcat
             */
            try {
                oForm.setMaxThreadsByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MaxThreadsByConnectorTomcat", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentThreadCountByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentThreadCountByConnectorTomcat", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentThreadBusyByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentThreadBusyByConnectorTomcat", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setBytesReceivedByConnectorTomcat(((Long) JonasManagementRepr.getAttribute(on,
                        "BytesReceivedByConnectorTomcat", serverName)).longValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setBytesSentByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "BytesSentByConnectorTomcat", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setErrorCountByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "ErrorCountByConnectorTomcat", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setProcessingTimeByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "ProcessingTimeByConnectorTomcat", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setRequestCountByConnectorTomcat((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "RequestCountByConnectorTomcat", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            /*
             * Tx
             */
            try {
                oForm.setTotalBegunTransactions((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "TotalBegunTransactions", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setTotalCommittedTransactions((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "TotalCommittedTransactions", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setTotalCurrentTransactions((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "TotalCurrentTransactions", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setTotalExpiredTransactions((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "TotalExpiredTransactions", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setTotalRolledbackTransactions((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "TotalRolledbackTransactions", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            /*
             * Worker Pool
             */
            try {
                oForm.setCurrentWorkerPoolSize((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentWorkerPoolSize", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMaxWorkerPoolSize((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MaxWorkerPoolSize", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMinWorkerPoolSize((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MinWorkerPoolSize", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            /*
             * JCA
             */
            try {
                oForm.setBusyMaxJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "BusyMaxJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setBusyMinJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "BusyMinJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setConnectionFailuresJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "ConnectionFailuresJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setConnectionLeaksJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "ConnectionLeaksJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentBusyJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentBusyJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentInTxJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentInTxJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentOpenedJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentOpenedJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentWaitersJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentWaitersJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setInitPoolSizeJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "InitPoolSizeJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolMaxSizeJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolMaxSizeJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolMinSizeJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolMinSizeJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolMaxWaitersJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolMaxWaitersJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolMaxWaitTimeJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolMaxWaitTimeJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolMaxOpentimeJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolMaxOpentimeJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPhysicalConnectionOpenedCountJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PhysicalConnectionOpenedCountJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPstmtMaxJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PstmtMaxJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setRejectedFullJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "RejectedFullJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setRejectedOpenJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "RejectedOpenJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setRejectedOtherJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "RejectedOtherJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setRejectedTimeoutJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "RejectedTimeoutJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setXaServedOpenJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "XaServedOpenJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setWaiterCountJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "WaiterCountJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setWaitersHighJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "WaitersHighJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setWaitersHighRecentJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "WaitersHighRecentJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setWaitingHighJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "WaitingHighJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setWaitingHighRecentJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "WaitingHighRecentJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setWaitingTimeJCAConnection((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "WaitingTimeJCAConnection", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            /*
             * JMS
             */
            try {
                oForm.setJmsQueuesNbMsgsReceiveSinceCreation((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "JmsQueuesNbMsgsReceiveSinceCreation", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJmsQueuesNbMsgsSendToDMQSinceCreation((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "JmsQueuesNbMsgsSendToDMQSinceCreation", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJmsQueuesNbMsgsDeliverSinceCreation((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "JmsQueuesNbMsgsDeliverSinceCreation", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJmsTopicsNbMsgsReceiveSinceCreation((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "JmsTopicsNbMsgsReceiveSinceCreation", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJmsTopicsNbMsgsSendToDMQSinceCreation((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "JmsTopicsNbMsgsSendToDMQSinceCreation", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setJmsTopicsNbMsgsDeliverSinceCreation((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "JmsTopicsNbMsgsDeliverSinceCreation", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            /*
             * EJB
             */
            try {
                oForm.setCurrentNumberOfBMP((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfBMP", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfCMP((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfCMP", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfEJB((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfEJB", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfMDB((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfMDB", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfSBF((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfSBF", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfSBL((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfSBL", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfEBInMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfEBInMemory", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMaxNumberOfEBInMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MaxNumberOfEBInMemory", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMinPoolSizeEB((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MinPoolSizeEB", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolSizeEB((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolSizeEB", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfSBFInMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfSBFInMemory", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMaxNumberOfSBFInMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MaxNumberOfSBFInMemory", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMinPoolSizeSBF((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MinPoolSizeSBF", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolSizeSBF((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolSizeSBF", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setCurrentNumberOfSBLInMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "CurrentNumberOfSBLInMemory", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMaxNumberOfSBLInMemory((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MaxNumberOfSBLInMemory", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setMinPoolSizeSBL((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "MinPoolSizeSBL", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }
            try {
                oForm.setPoolSizeSBL((int) new Integer(JonasManagementRepr.getAttribute(on,
                        "PoolSizeSBL", serverName).toString()).intValue());
            } catch (RuntimeException e) {
                // Attibute missing
            }

        } catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }

        // Forward to the jsp.
        return (p_Mapping.findForward("DisplayNode"));
    }
}
